package com.yaohun.itemlibrary.gui;

import com.yaohun.itemlibrary.data.SortData;
import com.yaohun.itemlibrary.main;
import com.yaohun.itemlibrary.manage.SortManager;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class SortAllGui implements Listener {

    public static String invTitle = "我的世界物品库 - 导航分类";

    @EventHandler
    public void onClick(InventoryClickEvent e) {
        int rawSlot = e.getRawSlot();
        Inventory inv = e.getInventory();
        Player p = (Player) e.getWhoClicked();
        if (inv != null && inv.getTitle().contains(invTitle)) {
            e.setCancelled(true);
            ItemStack item = e.getCurrentItem();
            if(!DemonAPI.itemIsNull(item)){
                NBTItem nbt = new NBTItem(item);
                if(nbt.hasKey("sortName")){
                    String sortName = nbt.getString("sortName");
                    SortGui.OpenGui(p,sortName,1);
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1.6F,1.8F);
                }
            }
        }
    }

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 36, invTitle);
        SortManager sortManager = main.sortManager;
        for (String sortName : sortManager.getSortDataLinkedHashMap().keySet()){
            SortData sortData = sortManager.getSortData(sortName);
            inv.addItem(showTypeStack(sortData));
        }
        p.openInventory(inv);
    }


    public static ItemStack showTypeStack(SortData sortData){
        ItemStack item = sortData.getShowStack();
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§6§l"+sortData.getSortName());
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击打开 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTItem nbt = new NBTItem(item);
        nbt.setString("sortName",sortData.getSortName());
        return nbt.getItem();
    }
}
