package com.yaohun.itemlibrary.gui;

import cn.hamster3.cdapi.CDTimeAPI;
import com.yaohun.itemlibrary.api.ItemKuAPI;
import com.yaohun.itemlibrary.data.SortData;
import com.yaohun.itemlibrary.main;
import com.yaohun.itemlibrary.manage.SortManager;
import de.tr7zw.itemnbtapi.NBTItem;
import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class SortGui implements Listener {

    public static String invTitle = "我的世界物品库 ";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        int rawSlot = e.getRawSlot();
        Inventory inv = e.getInventory();
        Player p = (Player) e.getWhoClicked();
        if(inv != null && inv.getTitle().contains(invTitle)){
            e.setCancelled(true);
            if(rawSlot == 45){
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                NBTItem nbtItem = new NBTItem(e.getCurrentItem());
                String sortName = nbtItem.getString("sortName");
                int page = nbtItem.getInteger("page");
                if (page >= 2 && page <= 5) {
                    SortGui.OpenGui(p,sortName,page-1);
                } else {
                    SortAllGui.OpenGui(p);
                }
            }
            if(rawSlot == 53){
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                NBTItem nbtItem = new NBTItem(e.getCurrentItem());
                String sortName = nbtItem.getString("sortName");
                int page = nbtItem.getInteger("page");
                if (page >= 1 && page <= 4) {
                    SortGui.OpenGui(p,sortName,page+1);
                } else {
                    DemonAPI.sendMessage(p,"已经是最后一页了！");
                }
            }
            if(rawSlot == 49){
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1.6F, 1.8F);
                DemonAPI.sendMessage(p,"刷新成功！");
                NBTItem nbtItem = new NBTItem(e.getCurrentItem());
                String sortName = nbtItem.getString("sortName");
                int page = nbtItem.getInteger("page");
                OpenGui(p,sortName,page);
            }
            if(rawSlot >= 0 && rawSlot < 45){
                ItemStack item = e.getCurrentItem();
                if(!DemonAPI.itemIsNull(item)){
                    NBTItem nbtItem = new NBTItem(item);
                    if(nbtItem.hasKey("itemKey")){
                        String sortName = nbtItem.getString("sortName");
                        String itemKey = nbtItem.getString("itemKey");
                        ItemStack stack = ItemKuAPI.getSortItemStack(sortName,itemKey);
                        if(e.getClick() == ClickType.LEFT) {
                            stack.setAmount(1);
                            p.getInventory().addItem(stack);
                        }else if(e.getClick() == ClickType.RIGHT){
                            stack.setAmount(10);
                            p.getInventory().addItem(stack);
                        }else if(e.getClick() == ClickType.MIDDLE){
                            stack.setAmount(64);
                            p.getInventory().addItem(stack);
                        }
                        p.playSound(p.getLocation(), Sound.ENTITY_CHICKEN_EGG,1,2);
                    }
                }
            }
        }
    }

    public static void OpenGui(Player p,String sortName,int page){
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        SortManager sortManager = main.sortManager;
        if (sortManager.isSortFileExit(sortName)) { // 检查排序文件是否存在
            List<ItemStack> itemsListID = new ArrayList<>();
            SortData sortData = sortManager.getSortData(sortName);
            inv = Bukkit.createInventory(null,54,invTitle+"[§6§l"+sortName+"§r]");
            for (String itemKey : sortData.getStackLinkedMap().keySet()) {
                ItemStack item = sortData.getStackLinkedMap().get(itemKey).clone();
                ItemStack stack = ShowStack(sortName, itemKey, item); // 获取每个物品堆叠
                itemsListID.add(stack); // 添加物品到列表
            }
            if (itemsListID.size() >= 1) { // 如果物品列表不为空
                if (page == 1) { // 如果是第一页
                    for (int i = 0; i < itemsListID.size(); i++) { // 遍历物品列表
                        ItemStack item = itemsListID.get(i);
                        inv.addItem(item); // 添加物品到物品栏
                    }
                } else { // 如果是第二页或之后
                    int startIndex = 45 * (page - 1); // 计算起始索引
                    for (int i = startIndex; i < itemsListID.size(); i++) {
                        ItemStack item = itemsListID.get(i);
                        inv.addItem(item); // 添加物品到物品栏
                    }
                }
            }
        }
        for (int i = 46;i<53;i++){
            inv.setItem(i, DemonAPI.glass(0,"§r"));
        }
        inv.setItem(45,Paper_Butt("§a上一页",sortName,page));
        inv.setItem(49,refreshData(sortName,page));
        inv.setItem(53,Paper_Butt("§a下一页",sortName,page));
        p.openInventory(inv);
    }

    public static ItemStack ShowStack(String sortName,String itemKey,ItemStack stack){
        ItemStack item = stack.clone();
        item.setAmount(1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(meta.getDisplayName()+" §7#"+itemKey);
        item.setItemMeta(meta);
        NBTItem nbt = new NBTItem(item);
        nbt.setString("sortName",sortName);
        nbt.setString("itemKey",itemKey);
        return nbt.getItem();
    }

    public static ItemStack Paper_Butt(String name,String sortName,int page){
        ItemStack item = new ItemStack(Material.ARROW);
        item.setAmount(page);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击翻页 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTItem nbt = new NBTItem(item);
        nbt.setString("sortName",sortName);
        nbt.setInteger("page",page);
        return nbt.getItem();
    }
    public static ItemStack refreshData(String sortName,int page){
        ItemStack item = new ItemStack(Material.TOTEM);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§c刷新缓存数据");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★ §7点击执行 §a§l★");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTItem nbt = new NBTItem(item);
        nbt.setString("sortName",sortName);
        nbt.setInteger("page",page);
        return nbt.getItem();
    }
}
